Add 64-bit to 32-bit trunc pattern.
[oota-llvm.git] / utils / buildit / build_llvm
1 #!/bin/sh
2 # LLVM LOCAL file B&I
3
4 set -x
5
6 # Build LLVM the "Apple way".
7 # Parameters:
8
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 HOSTS="$1"
13
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
18 TARGETS="$2"
19
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
22 ORIG_SRC_DIR="$3"
23
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
26 DEST_ROOT="$4"
27
28 # The fifth parameter is the place where the compiler will be copied once it's
29 # built.
30 DEST_DIR="$5"
31
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
34 # resulting compiler.
35 SYM_DIR="$6"
36
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
39 LLVM_ASSERTIONS="$7"
40
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
42 # build.
43 LLVM_OPTIMIZED="$8"
44
45 # The ninth parameter is a yes/no that indicates whether libLTO.dylib
46 # should be installed.
47 INSTALL_LIBLTO="$9"
48
49 # A yes/no parameter that controls whether to cross-build for an ARM host.
50 ARM_HOSTED_BUILD="${10}"
51
52 # A yes/no parameter that controls whether to cross-build for the iOS simulator
53 IOS_SIM_BUILD="${11}"
54
55 # The version number of the submission, e.g. 1007.
56 LLVM_SUBMIT_VERSION="${12}"
57
58 # The subversion number of the submission, e.g. 03.
59 LLVM_SUBMIT_SUBVERSION="${13}"
60
61 # The current working directory is where the build will happen. It may already
62 # contain a partial result of an interrupted build, in which case this script
63 # will continue where it left off.
64 DIR=`pwd`
65
66 DARWIN_VERS=`uname -r | sed 's/\..*//'`
67 echo DARWIN_VERS = $DARWIN_VERS
68
69 ################################################################################
70 # Run the build.
71
72 # Create the source tree we'll actually use to build, deleting
73 # tcl since it doesn't actually build properly in a cross environment
74 # and we don't really need it.
75 SRC_DIR=$DIR/src
76 rm -rf $SRC_DIR || exit 1
77 mkdir $SRC_DIR || exit 1
78 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
79 # We can't use the top-level Makefile as-is.  Remove the soft link:
80 rm $SRC_DIR/Makefile || exit 1
81 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
82 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
83
84 # Build the LLVM tree universal.
85 mkdir -p $DIR/obj-llvm || exit 1
86 cd $DIR/obj-llvm || exit 1
87
88 if [ "$ARM_HOSTED_BUILD" = yes ]; then
89   # The cross-tools' build process expects to find an existing cross toolchain
90   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
91   rm -rf $DIR/bin || exit 1
92   mkdir $DIR/bin || exit 1
93   for prog in ar nm ranlib strip lipo ld as ; do
94     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
95     T=`xcrun -sdk $SDKROOT -find ${prog}`
96     echo '#!/bin/sh' > $P || exit 1
97     echo 'exec '$T' "$@"' >> $P || exit 1
98     chmod a+x $P || exit 1
99   done
100   # Set up the links for clang.
101   for prog in clang clang++ ; do
102     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
103     T=`xcrun -sdk $SDKROOT -find ${prog}`
104     echo '#!/bin/sh' > $P || exit 1
105     echo 'exec '$T' -arch armv7 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
106     chmod a+x $P || exit 1
107   done
108
109   PATH=$DIR/bin:$PATH
110 fi
111
112 if [ "$ARM_HOSTED_BUILD" = yes ]; then
113   configure_opts="--enable-targets=arm --host=arm-apple-darwin10 \
114                   --target=arm-apple-darwin10 --build=i686-apple-darwin10"
115 elif [ "$IOS_SIM_BUILD" = yes ]; then
116   # Use a non-standard "darwin_sim" host triple to trigger a cross-build.
117   configure_opts="--enable-targets=x86 --host=i686-apple-darwin_sim \
118                   --build=i686-apple-darwin10"
119 else
120   configure_opts="--enable-targets=arm,x86,cbe"
121 fi
122
123 if [ \! -f Makefile.config ]; then
124   $SRC_DIR/configure --prefix=$DEST_DIR$DEST_ROOT $configure_opts \
125     --enable-assertions=$LLVM_ASSERTIONS \
126     --enable-optimized=$LLVM_OPTIMIZED \
127     --disable-bindings \
128     || exit 1
129 fi
130
131 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
132
133 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
134     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
135     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
136     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
137 fi
138
139 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
140     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
141 else
142     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
143 fi
144
145 # Figure out how many make processes to run.
146 SYSCTL=`sysctl -n hw.activecpu`
147 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
148 # Builders can default to 2, since even if they are single processor,
149 # nothing else is running on the machine.
150 if [ -z "$SYSCTL" ]; then
151     SYSCTL=2
152 fi
153 JOBS_FLAG="-j $SYSCTL"
154
155 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
156     UNIVERSAL_SDK_PATH=$SDKROOT \
157     NO_RUNTIME_LIBS=1 \
158     DISABLE_EDIS=1 \
159     REQUIRES_RTTI=1 \
160     DEBUG_SYMBOLS=1 \
161     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
162     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
163     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
164     VERBOSE=1
165
166 if [ $? != 0 ] ; then
167     echo "error: LLVM 'make' failed!"
168     exit 1
169 fi 
170
171 ################################################################################
172 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
173 # $DEST_DIR, with occasional 'lipo' commands.
174
175 cd $DEST_DIR || exit 1
176
177 # Clean out DEST_DIR in case -noclean was passed to buildit.
178 rm -rf * || exit 1
179
180 cd $DIR/obj-llvm || exit 1
181
182 # Install the tree into the destination directory.
183 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
184     NO_RUNTIME_LIBS=1 \
185     DISABLE_EDIS=1 \
186     DEBUG_SYMBOLS=1 \
187     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
188     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
189     OPTIMIZE_OPTION='-O3' VERBOSE=1 install
190
191 if ! test $? == 0 ; then
192     echo "error: LLVM 'make install' failed!"
193     exit 1
194 fi 
195
196 # Install Version.h
197 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
198 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
199     LLVM_MINOR_VERSION=0
200 fi
201 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
202 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
203 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
204
205 # Find the right version of strip to use.
206 STRIP=strip
207 if [ -n "$SDKROOT" ]; then
208   STRIP=`xcrun -sdk $SDKROOT -find strip`
209 fi
210
211 if [ "x$LLVM_DEBUG" != "x1" ]; then
212     # Strip local symbols from llvm libraries.
213     #
214     # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
215     # PPC objects!
216     $STRIP -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
217     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
218         $STRIP -Sxl $f
219     done
220 fi
221
222 # Copy over the tblgen utility.
223 cp `find $DIR -name tblgen` $DEST_DIR$DEST_ROOT/bin
224
225 # Remove .dir files 
226 cd $DEST_DIR$DEST_ROOT
227 rm -f bin/.dir etc/llvm/.dir lib/.dir
228
229 # Remove PPC64 fat slices.
230 cd $DEST_DIR$DEST_ROOT/bin
231 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
232     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
233         -exec lipo -extract ppc -extract i386 {} -output {} \;
234 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
235     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
236         -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
237 else
238     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
239         -exec lipo -extract i386 -extract x86_64 {} -output {} \;
240 fi
241
242 # The Hello dylib is an example of how to build a pass.
243 # The BugpointPasses module is only used to test bugpoint.
244 # These unversioned dylibs cause verification failures, so do not install them.
245 # (The wildcards are used to match a "lib" prefix if it is present.)
246 rm $DEST_DIR$DEST_ROOT/lib/*LLVMHello.dylib
247 rm $DEST_DIR$DEST_ROOT/lib/*BugpointPasses.dylib
248
249 # Compress manpages
250 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
251 gzip -f $MDIR/*
252
253 ################################################################################
254 # Create SYM_DIR with information required for debugging.
255
256 # Figure out how many make processes to run.
257 SYSCTL=`sysctl -n hw.activecpu`
258
259 # hw.activecpu only available in 10.2.6 and later
260 if [ -z "$SYSCTL" ]; then
261   SYSCTL=`sysctl -n hw.ncpu`
262 fi
263
264 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
265 # can default to 2, since even if they are single processor, nothing else is
266 # running on the machine.
267 if [ -z "$SYSCTL" ]; then
268   SYSCTL=2
269 fi
270
271 cd $SYM_DIR || exit 1
272
273 # Clean out SYM_DIR in case -noclean was passed to buildit.
274 rm -rf * || exit 1
275
276 # Generate .dSYM files
277 find $DEST_DIR -perm -0111 -type f \
278     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
279     -print | xargs -n 1 -P ${SYSCTL} dsymutil
280
281 # Save .dSYM files and .a archives
282 cd $DEST_DIR || exit 1
283 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
284     | cpio -pdml $SYM_DIR || exit 1
285
286 # Save source files.
287 mkdir $SYM_DIR/src || exit 1
288 cd $DIR || exit 1
289 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
290     | cpio -pdml $SYM_DIR/src || exit 1
291
292 ################################################################################
293 # Install and strip libLTO.dylib
294
295 cd $DEST_DIR$DEST_ROOT
296 if [ "$INSTALL_LIBLTO" = "yes" ]; then
297   DT_HOME="$DEST_DIR/Developer/usr"
298   mkdir -p $DT_HOME/lib
299   mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
300
301   # Save a copy of the unstripped dylib
302   mkdir -p $SYM_DIR/Developer/usr/lib
303   cp $DT_HOME/lib/libLTO.dylib $SYM_DIR/Developer/usr/lib/libLTO.dylib
304
305   # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
306   # PPC objects!
307   $STRIP -arch all -Sl $DT_HOME/lib/libLTO.dylib
308
309   if [ "x$DISABLE_USR_LINKS" == "x" ]; then
310     # Add a symlink in /usr/lib for B&I.
311     mkdir -p $DEST_DIR/usr/lib/
312     (cd $DEST_DIR/usr/lib && \
313       ln -s ../../Developer/usr/lib/libLTO.dylib ./libLTO.dylib)
314   fi
315 else
316   rm -f lib/libLTO.dylib
317 fi
318 rm -f lib/libLTO.a lib/libLTO.la
319
320 # Omit lto.h from the result.  Clang will supply.
321 find $DEST_DIR$DEST_ROOT -name lto.h -delete
322
323 ################################################################################
324 # Remove debugging information from DEST_DIR.
325
326 cd $DIR || exit 1
327
328 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
329 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
330
331 # Strip debugging information from files
332 #
333 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
334 # PPC objects!
335 find $DEST_DIR -perm -0111 -type f \
336     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
337     -print | xargs -n 1 -P ${SYSCTL} $STRIP -arch all -Sl
338
339 chgrp -h -R wheel $DEST_DIR
340 chgrp -R wheel $DEST_DIR
341
342 ################################################################################
343 # Remove the docs directory
344
345 rm -rf $DEST_DIR$DEST_ROOT/docs
346
347 ################################################################################
348 # w00t! Done!
349
350 exit 0